## guitarix 0.20.2

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, os, re, shutil
import Build, Utils, Options, Logs, Configure, Scripting
from Constants import HEXVERSION
from Configure import ConfigurationError
from TaskGen import feature
import wscript_dsp

# Waf version check, for global waf installs

try:
    from Constants import WAFVERSION
except:
    WAFVERSION='1.0.0'
if WAFVERSION[:3] != '1.5':
    print 'Incompatible Waf, use 1.5'
    sys.exit (1)

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'
use_2to3 = True

# used by waf dist and waf build
VERSION='0.20.2'
APPNAME='guitarix'
APPNAME1='guitarix'

good_faust_versions = ['0.9.43']

g_maxlen = 40 # maximum width of message for 2-column display


################################################################
# options defined for waf configure
################################################################

def set_options(opt):
    
    def add_enable_option (option, desc, group=None, disable=False):
        if group == None:
            group = opt
        option_ = option.replace ('-', '_')
        group.add_option ('--enable-' + option, action='store_true',
            default=False, help='Enable ' + desc, dest='enable_' + option_)
        group.add_option ('--disable-' + option, action='store_true',
            default=disable, help='Disable ' + desc, dest='disable_' + option_)

    opt.tool_options('gcov')
    opt.tool_options ('intltool')
    group = opt.add_option_group ('Localization and documentation', '')
    add_enable_option ('nls', 'native language support', group)

    opt.tool_options('compiler_cxx')
    comp = opt.get_option_group("--check-cxx-compiler")

    comp.add_option('--debug',
                    action='store_const',
                    default=False,
                    const=True,
                    help='set compiler flags for a debug build')

    comp.add_option('--cxxflags-release',
                    type='string',
                    default='-O3 -DNDEBUG',
                    dest='cxxflags_release',
                    help='additional C++ compiler flags for release version (not used if --debug) [Default: %default]')

    comp.add_option('--cxxflags-debug',
                    type='string',
                    default='-O2 -g -fstack-protector-all',
                    dest='cxxflags_debug',
                    help='additional C++ compiler flags for debug version (only used if --debug) [Default: %default]')

    comp.add_option('--cxxflags',
                    type='string',
                    default='-Wall', # -fomit-frame-pointer -ffast-math -fstrength-reduce -mmmx -mfpmath=sse -DUSE_XMMINTRIN -pipe
                    dest='cxxflags',
                    help='C++ base compiler flags [Default: %default]')

    comp.add_option('--optimization',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='automatically select additional C++ compiler optimization flags for the current platform')

    opt.recurse('libgxw/gxw')
    opt.recurse('libgxwmm/gxwmm')

    comp = opt.add_option_group("Additional Library Options")

    comp.add_option('--includeresampler',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-resample libary (Default NO)')

    comp.add_option('--includeconvolver',
                    action='store_const',
                    default=False,
                    const=True,
                    help='build with included local zita-convolver libary (Default NO)')


    comp.add_option('--no_ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help='dont build ladspa plugins (Default yes)')

    comp.add_option('--experimental-ladspa',
                    action='store_const',
                    default=False,
                    const=True,
                    help=('build with experimental ladspa plugin'
                          ' (in src/ladsp, will not be installed'))

    faust = opt.add_option_group("Faust-Compiler")

    if len(good_faust_versions) == 1:
        faust_vers_str = good_faust_versions[0]
    else:
        faust_vers_str = "in [%s]" % ", ".join(good_faust_versions)

    faust.add_option('--faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help=('use faust even if the installed version is not %s'
                           % faust_vers_str))

    faust.add_option('--no-faust',
                     action='store_const',
                     default=False,
                     const=True,
                     help="don't use faust, use the pre-built files in faust-generated")

    faust.add_option('--faust-float',
                     action='store_const',
                     default=False,
                     const=True,
                     help="build with faust, single precision")


    ladspa = opt.add_option_group("LADSPA Options (installing ladspa modules)")

    ladspa.add_option('--ladspadir',
                    type='string',
                    help='LADSPA plugin directory [Default: <prefix>/lib/ladspa]')

    opt.recurse('pygxw')
    opt.recurse('glade-gxw')

    opt.tool_options('compiler_cc') # for pygxw and glade-gxw
    opt.add_option('--no-pkg',
                   action='store_const',
                   default=False,
                   const=True,
                   help=("don't include debian directory in tarfile"
                         " (option only for command 'dist')"))


################################################################
# waf configure
################################################################

################################################################
# configuration display helper functions
#

def print_msg(msg, nl=True):
    if HEXVERSION > 0x10500:
        s = sys.stderr
    else:
        s = sys.stdout
    if nl:
        t = "\n"
    else:
        t = " "
    s.write(msg+t)

# a bit of waf display formatting
def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Utils.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

def error_msg(msg):
    Utils.pprint('RED', msg)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'CYAN')
    else:
        display_msg(msg, "no", 'YELLOW')

################################################################
# configuration utility functions
#

def option_enabled (option):
    if getattr (Options.options, 'enable_' + option):
        return True
    if getattr (Options.options, 'disable_' + option):
        return False
    return True

def append_optimization_flags(cxxflags):
    cpu_model = None
    x86_flags = None
    try:
        for line in file("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        display_msg("Checking CPU Architecture",
                    "cpu model not found in /proc/cpuinfo",
                    "YELLOW")
        return None
    model = cpu_model.split()
    arch = os.uname()[4]
    if "AMD" in model and "x86_64" in arch:
        cxxflags.append ("-march=k8")
    elif "AMD" in model and "Sempron(tm)" in model:
        cxxflags.append ("-march=native")
    elif "Geode" in model :
        cxxflags.append ("-march=geode")
    elif "Core" in model and "x86_64" in arch:
        cxxflags.append ("-march=core2")
    elif "i386" in arch:
        cxxflags.append ("-march=i386")
    elif "i486" in arch:
        cxxflags.append ("-march=i486")
    elif "i586" in arch:
        cxxflags.append ("-march=i586")
    elif "i686" in arch:
        cxxflags.append ("-march=i686")
    else:
        cxxflags.append ("-march=native")

    if "mmx" in x86_flags:
        cxxflags.append ("-mmmx")
    if "3dnow" in x86_flags:
        cxxflags.append ("-m3dnow")

    if "sse5" in x86_flags:
        cxxflags.append ("-msse5")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_2" in x86_flags:
        cxxflags.append ("-msse4.2")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4_1" in x86_flags:
        cxxflags.append ("-msse4.1")
        cxxflags.append ("-mfpmath=sse")
    elif "ssse3" in x86_flags:
        cxxflags.append ("-mssse3")
        cxxflags.append ("-mfpmath=sse")
    elif "sse4" in x86_flags:
        cxxflags.append ("-msse4")
        cxxflags.append ("-mfpmath=sse")
    elif "sse3" in x86_flags:
        cxxflags.append ("-msse3")
        cxxflags.append ("-mfpmath=sse")
    elif "sse2" in x86_flags:
        cxxflags.append ("-msse2")
        cxxflags.append ("-mfpmath=sse")
        #cxxflags.append ("-DUSE_XMMINTRIN")
    elif "sse" in x86_flags:
        cxxflags.append ("-msse")
        cxxflags.append ("-mfpmath=sse")
        # cxxflags.append ("-DUSE_XMMINTRIN")

    if not Options.options.debug:
        cxxflags.append ("-fomit-frame-pointer")
    cxxflags.append ("-ftree-loop-linear")
    cxxflags.append ("-ffinite-math-only")
    cxxflags.append ("-fno-math-errno")
    cxxflags.append ("-fno-signed-zeros")
    #cxxflags.append ("-ffast-math") # quicker but doesn't seem to work (difference in sound output)
    #cxxflags.append ("-malign-double")
    cxxflags.append ("-fstrength-reduce")
    cxxflags.append ("-pipe")
    return cpu_model

@Configure.conf
def cfg_get_variable(self, package, variable, prefix=""):
    p = Utils.pproc.Popen(["pkg-config", "--variable="+variable, package],
                          stdout=Utils.pproc.PIPE, shell=False)
    v = p.communicate()[0].strip()
    if p.returncode or not v:
        self.fatal('fail to get variable %s for package %s' % (variable, package))
    self.env[prefix+variable.upper()] = v


################################################################
# configuration helper functions
#

def check_faust(conf):
    if Options.options.no_faust:
        conf.env['FAUST'] = None
        return
    conf.find_program("faust", var='FAUST')
    if not conf.env['FAUST']:
        return
    try:
        s = Utils.cmd_output('%s --version' % conf.env['FAUST'])
    except ValueError:
        Logs.warn('count not execute faust')
        return
    m = re.match(r".*Version\s*(.*)", s)
    if not m:
        Logs.warn('could not determine faust version')
    vers = m.group(1)
    conf.env["FAUST_VERSION"] = vers
    if vers not in good_faust_versions and not Options.options.faust:
        conf.env['FAUST'] = None
        conf.check_message_custom('faust','version',"can't use %s (check ./waf --help)" % vers,color='YELLOW')
    else:
        conf.check_message('faust','version',1,vers)
    conf.env['FAUST_DOUBLE'] = not Options.options.faust_float

def check_boost(conf):
    boost_atleast_version = 104000
    boost_atleast_vermsg = "1.40"
    code="""
    #include <boost/version.hpp>
    #include <boost/format.hpp>
    #include <boost/thread.hpp>
    #if BOOST_VERSION < %d
    #error
    #endif
    int main(){ return 0; }
    """ % boost_atleast_version
    msg = "Checking for boost_thread%%s >= %s" % boost_atleast_vermsg
    try:
        conf.check_cxx(
            msg = msg % "", fragment=code, lib="boost_thread", uselib_store="BOOST_THREAD",
            errmsg="not found, trying boost_thread-mt", mandatory=1)
    except ConfigurationError:

=== pixmaps/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import Build

# start each filename with a space
pixmap_files  = ''
pixmap_files += ' gx_on.png'
pixmap_files += ' gx_off.png'  
pixmap_files += ' jackd_on.png'
pixmap_files += ' jackd_off.png'  
pixmap_files += ' gx_bypass.png'  
pixmap_files += ' gx_head.png' 
pixmap_files += ' gx_head-midi.png'
pixmap_files += ' gx_head-warn.png'

def configure(conf):
    pass

def build(bld):
    bld.install_files(bld.env['GX_PIXMAPS_DIR'], pixmap_files, chmod=0644)

=== pygxw/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

import Logs, Utils, Options

def set_options(opt):
    grp = opt.get_option_group("--shared-lib")
    grp.add_option('--python-wrapper',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('build python wrapper for library'),
                   )

def configure(conf):
    if not Options.options.python_wrapper:
        return
    conf.env["GX_PYTHON_WRAPPER"] = True
    conf.env["GXW_SHARED"] = True
    conf.check_python_headers()
    conf.check_cfg(package='pygtk-2.0', args='--cflags --libs', uselib_store='PYGTK' ,mandatory=True)
    conf.cfg_get_variable(package='pygtk-2.0', variable='defsdir')
    conf.check_python_module("numpy")

def h2defs(task):
    sources = " ".join(["'%s'" % v.srcpath(task.env) for v in task.inputs])
    path = task.generator.path
    lib = path.find_resource(task.generator.lib).srcpath(task.env)
    fltr = path.find_resource(task.generator.filter).srcpath(task.env)
    dst = task.outputs[0].bldpath(task.env)
    cmd = ("python '%s'/defsgen.py -m gx -l %s -f '%s' %s > '%s' && cat '%s' >> '%s'"
           % (task.env["CODEGENDIR"], lib, fltr, sources, dst, fltr, dst))
    Logs.debug("runner: system command -> %s" % cmd)
    return Utils.exec_command(cmd, shell=True)

def defs2c(task):
    ovr = task.inputs[0].srcpath(task.env)
    src = task.inputs[1].srcpath(task.env)
    dst = task.outputs[0].bldpath(task.env)
    defsdir = task.env["DEFSDIR"]
    cmd = ("pygobject-codegen-2.0"
           " --prefix gxw"
           " --register '%s'/gdk-types.defs"
           " --register '%s'/gtk-types.defs"
           " --override '%s'"
           " --outfilename '%s'"
           " '%s'"
           " > '%s'"
           % (defsdir, defsdir, ovr, dst, src, dst))
    Logs.debug("runner: system command -> %s" % cmd)
    return Utils.exec_command(cmd,shell=True)

def build(bld):
    if not bld.env["GX_PYTHON_WRAPPER"]:
        return
    bld.add_group()
    sources = ["GxTuner.h",
               "GxFastMeter.h",
               "GxWaveView.h",
               "GxRegler.h",
               "GxSelector.h",
               "GxSwitch.h",
               "GxToggleImage.h",
               "GxControlParameter.h",
               "GxIREdit.h",
               "GxRadioButton.h",
               "GxWheel.h",
               "GxKnob.h",
               "GxBigKnob.h",
               "GxSmallKnob.h",
               "GxHSlider.h",
               "GxMiniSlider.h",
               "GxVSlider.h",
               "GxEQSlider.h",
               "GxPaintBox.h",
               "GxMeterScale.h",
               "GxGradient.h",
               "GxValueDisplay.h",
               ]
    bld(name = "h2defs",
        target = "gxw.defs",
        rule = h2defs,
        source = ["../libgxw/gxw/"+v for v in sources],
        lib = "../libgxw/gxw/libgxw.so",
        filter = "gxw-manual.defs",
        )
    bld(name="defs2c",
        target = "gxw.c",
        rule = defs2c,
        source = ['gxw.override','gxw.defs'],
        after = "h2defs",
        )
    bld.add_group()
    prog = bld(
        features = ['cc','cxx','pyext','cshlib'],
        source = ['gxw.c','gxw-module.c'],
        target = 'gxw',
        uselib = ['PYGOBJECT','PYGTK','GTK2'],
        ccflags = ["-g"],
        includes = ['../libgxw'],
        )
    if bld.env["GX_LIB_SHARED"]:
        prog.libpath = [bld.path.find_dir("../libgxw/gxw").bldpath(bld.env)]
        prog.lib = ["gxw"]
    else:
        prog.uselib_local = ['gxw']

=== rcstyles/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import Build

gxstyle_files = [
    'gx12b.png',
    'gx14b.png',
    'gx18.png',
    'gxhead.png',
    'gx_green18.png',
    'gx_black18.png',
    'gx_gree18.png',
    'gx_green1.jpg',
    'gx_green2.jpg',
    'gx_head_gx1-alloy.rc',
    'gx_head_gx2-emerald.rc',
    'gx_head_gx3-dezert.rc',
    'gx_head_gx4-black.rc',
    'gx_head_gx5-gree.rc',
    'gx-dezert_18.png',
    'gx_dezert_12b.png',
    'gx_dezert_14b.png',
    'common.rc',
    'knob9.png',
    'tactile_knob_large_151f.png',
    'tactile_knob_small_99f.png',
    'tactile_knob_medium_151f.png',
    'tactile_switchit_off.png',
    'tactile_switchit_on.png',
    'tactile_wheel_101f.png',
    'tactile_h_wheel_101f.png',
    'tactile_backlit_switchit_off.png',
    'tactile_backlit_switchit_on.png',
    'smallknob9.png',
    'mittleknob9.png',
    'cairo1.jpg',
    'cairo2.jpg',
    'black1.png',
    'black2.png',
    ]

def configure(conf):
    pass

def build(bld):
    bld.install_files(bld.env['GX_STYLE_DIR1'], gxstyle_files, chmod=0644)

=== libgxw/gxw/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

import Logs, Utils, Configure, Options, os.path

def set_options(opt):
    pass

def configure(conf):
    if conf.env["GX_LIB_SHARED"] or conf.env["GXW_SHARED"]:
        conf.check_tool("libtool")

def img2c(task):
    mkname = lambda v: "pb_" + os.path.splitext(os.path.basename(str(v)))[0]
    sources = " ".join(["'%s' '%s'" % (mkname(v), v.srcpath(task.env)) for v in task.inputs])
    dst = task.outputs[0].bldpath(task.env)
    cmd = ("gdk-pixbuf-csource --raw --build-list %s > %s" % (sources, dst))
    Logs.debug("runner: system command -> %s" % cmd)
    return Utils.exec_command(cmd, shell=True)

def build_stock_images(bld):
    images = [
        "button_off.png",
        "button_on.png",
        "eqslider.png",
        "levelslider.png",
        "knob1.png",
        "led_off.png",
        "led_on.png",
        "minislider.png",
        "minitoggle_off.png",
        "minitoggle_on.png",
        "hslider.png",
        "smallknob1.png",
        "switchit_off.png",
        "switchit_on.png",
        "switch_off.png",
        "switch_on.png",
        "pbutton_on.png",
        "pbutton_off.png",
        "rbutton_on.png",
        "rbutton_off.png",
        "vslider.png",
        "wheel_back.png",
        "wheel_vertical_back.png",
        "wheel_fringe.png",
        "wheel_pointer.png",
        "tribe.png",
        "guitar.png",
        "gxhead.png",
        "gxhead_face.png",
        ]

    bld(name = "img2c",
        target = "gximages.cc",
        rule = img2c,
        source = ["../icons/"+v for v in images],
        )
    bld.add_group()

def build(bld):
    sources = [
        'gxinit.cpp',
        'GxFastMeter.cpp',
        'GxWaveView.cpp',
        'GxTuner.cpp',
        'GxRegler.cpp',
        'GxSelector.cpp',
        'GxSwitch.cpp',
        'GxToggleImage.cpp',
        'GxControlParameter.cpp',
        'GxIREdit.cpp',
        'GxRadioButton.cpp',
        'GxWheel.cpp',
        'GxWheelVertical.cpp',
        'GxKnob.cpp',
        'GxBigKnob.cpp',
        'GxSmallKnob.cpp',
        'GxSmallKnobR.cpp',
        'GxHSlider.cpp',
        'GxMiniSlider.cpp',
        'GxVSlider.cpp',
        'GxEQSlider.cpp',
        'GxLevelSlider.cpp',
        'GxPaintBox.cpp',
        'GxMeterScale.cpp',
        'GxGradient.cpp',
        'GxValueDisplay.cpp',
        'GxSimpleValueDisplay.cpp',
        ]
    build_stock_images(bld)
    if bld.env["GX_LIB_STATIC"]:
        # static library
        prog = bld(
            features = ['cxx', 'cstaticlib'],
            includes = ['.'],
            source = sources,
            uselib = ['GTHREAD', 'GTK2'],
            target = 'gxw',
            chmod=0755,
            )
    if bld.env["GX_LIB_SHARED"] or bld.env["GXW_SHARED"]:
        # shared library
        prog = bld(
            features = ['cxx', 'cshlib'],
            includes = ['.'],
            source = sources,
            uselib = ['GTHREAD', 'GTK2'],
            target = 'gxw',
            chmod=0755,
            )
        if bld.env["GX_LIB_SHARED"] or bld.env["GXW_SHARED_INSTALL"]:
            prog.features.append('libtool')
            prog.type = 'cshlib'
            prog.vnum = "0.1"
        else:
            prog.install_path = None

=== libgxwmm/gxwmm/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import Task, Options, Utils, Logs, shutil, os.path
from TaskGen import extension

def set_options(opt):
    grp = opt.add_option_group("Guitarix Widget Library")
    grp.add_option('--shared-lib',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('build shared library'),
                   )
    grp.add_option('--generate-cpp-wrapper',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('use the pre-built c++ library wrapper files'),
                   )

def configure(conf):
    conf.check_tool('misc')
    if Options.options.generate_cpp_wrapper:
        conf.cfg_get_variable(package='glibmm-2.4', variable='gmmprocdir')
        conf.cfg_get_variable(package='gtkmm-2.4', variable='gmmprocm4dir', prefix="GTK_")
        conf.cfg_get_variable(package='atkmm-1.6', variable='gmmprocm4dir', prefix="ATK_")
        conf.cfg_get_variable(package='pangomm-1.4', variable='gmmprocm4dir', prefix="PANGO_")
        conf.env["USE_GENERATED_CPP"] = False
    else:
        conf.env["USE_GENERATED_CPP"] = True
    if Options.options.shared_lib:
        conf.env["GX_LIB_SHARED"] = True
    else:
        conf.env["GX_LIB_STATIC"] = True

def template2cc(task):
    basename = os.path.splitext(
        os.path.basename(task.inputs[0].srcpath(task.env)))[0]
    srcdir = task.inputs[0].parent
    try:
        os.remove(task.outputs[0].bldpath(task.env))
    except OSError:
        pass
    try:
        os.mkdir(task.outputs[0].parent.bldpath(task.env) + "/private")
    except OSError:
        pass
    spath = srcdir.srcpath(task.env)
    dpath = srcdir.bldpath(task.env)
    cmd = ["%s/gmmproc" % task.env["GMMPROCDIR"],
           "--defs", dpath,
           "-I", spath,
           "-I", "%s" % task.env["GTK_GMMPROCM4DIR"],
           "-I", "%s" % task.env["ATK_GMMPROCM4DIR"],
           "-I", "%s" % task.env["PANGO_GMMPROCM4DIR"],
           basename,
           spath,
           dpath,
           ]
    Logs.debug("runner: system command -> %s" % cmd)
    ret = Utils.exec_command(cmd, shell=False)
    if ret != 0:
        return ret
    dpath += "/"
    spath += "/../gxwmm-generated/"
    try:
        shutil.copy2(dpath+basename+".cc", spath+basename+".cc")
        shutil.copy2(dpath+basename+".h", spath+basename+".h")
        shutil.copy2(dpath+"private/"+basename+"_p.h", spath+"private/"+basename+"_p.h")
    except (OSError, IOError), e:
        Logs.error("runner: cannot copy file -> %s" % e)
        return e.errno
    return 0

Task.task_type_from_func(
    'gmmproc',
    template2cc,
    color='BLUE',
    before='cxx')

@extension('.hg')
def process_hg(self, node):
        cc_node = node.change_ext('.cc')
        task = self.create_task('gmmproc', [node], [cc_node])
        task.after = ["gxwdefs"]
        task.deps_nodes.append(
            node.parent.find_resource(node.name.replace('.hg','.ccg')))
        task.deps_nodes.append(
            node.parent.find_or_declare('gxw.defs'))
        self.allnodes.append(cc_node)

def header2defs(task):
    sources = " ".join(["'%s'" % v.srcpath(task.env) for v in task.inputs[1:]])
    path = task.generator.path
    dst = task.outputs[0].bldpath(task.env)
    flt = task.inputs[0].srcpath(task.env)
    cmd = ("python '%s'/h2def.py -f '%s' -m gxw %s > '%s'"
           % (task.env["CODEGENDIR"], flt, sources, dst))
    Logs.debug("runner: system command -> %s" % cmd)
    return Utils.exec_command(cmd, shell=True)

def build_generate_wrapper(bld):
    header = ["GxTuner.h",
              "GxFastMeter.h",
              "GxWaveView.h",
              "GxRegler.h",
              "GxSelector.h",
              "GxSwitch.h",
              "GxToggleImage.h",
              "GxControlParameter.h",
              "GxIREdit.h",
              "GxRadioButton.h",
              "GxWheel.h",
              "GxWheelVertical.h",
              "GxKnob.h",
              "GxBigKnob.h",
              "GxSmallKnob.h",
              "GxSmallKnobR.h",
              "GxHSlider.h",
              "GxMiniSlider.h",
              "GxVSlider.h",
              "GxEQSlider.h",
              "GxLevelSlider.h",
              "GxPaintBox.h",
              "GxMeterScale.h",
              "GxGradient.h",
              "GxValueDisplay.h",
              "GxSimpleValueDisplay.h",
              ]
    header = ["../../libgxw/gxw/"+v for v in header]
    bld(features = ['cxx', 'cprogram'],
        source = "generate_defs_gxw.cc",
        includes = ["../../libgxw"],
        uselib = ['GTKMM'],
        lib    = 'glibmm_generate_extra_defs-2.4',
        uselib_local = "gxw",
        target = 'generate_defs_gxw',
        install_path = None,
        )
    bld.add_group()
    libdir = bld.path.find_dir("../../libgxw/gxw").bldpath(bld.env)
    e1 = 's/GdkEvent\\*/GdkEventButton*/'
    e2 = 's/return-type "const-gchar\\*"/return-type "gchar*"/'
    bld(name = "sigdefs",
        rule = ("LD_LIBRARY_PATH=\"%s\" ${SRC} | sed -e '"+e1+"' -e '"+e2+"'> ${TGT}") % libdir, #FIXME
        source = 'generate_defs_gxw',
        target = 'signals.defs',
        )
    bld(name = "mthdefs",
        rule = header2defs,
        source = ['filter.defs']+header,
        target = "methods.defs",
        )
    bld(name = "enumdefs",
        rule = bld.path.srcpath(bld.env)+"/enum.pl ${SRC} > ${TGT}",
        source = header,
        target = "enum.defs",
        )
    bld(name = "gxwdefs",
        rule = 'for f in ${SRC}; do echo "(include $(basename $f))"; done > ${TGT}',
        source = ["methods.defs","signals.defs","enum.defs"],
        target = "gxw.defs",
        after = ["sigdefs","mthdefs","enumdefs"],
        )
    bld(rule = "cp ${SRC} ${TGT}", 
        source = "docs.xml",
        target = "gxw_docs.xml",
        )

def build(bld):
    sources = [
        "controlparameter.hg",
        "switch.hg",
        "regler.hg",
        "knob.hg",
        "bigknob.hg",
        "smallknob.hg",
        "smallknobr.hg",
        "tuner.hg",
        "fastmeter.hg",
        "waveview.hg",
        "selector.hg",
        "toggleimage.hg",
        "iredit.hg",
        "radiobutton.hg",
        "wheel.hg",
        "wheelvertical.hg",
        "hslider.hg",
        "minislider.hg",
        "vslider.hg",
        "eqslider.hg",
        "levelslider.hg",
        "paintbox.hg",
        "meterscale.hg",
        #"gradient.hg",
        "valuedisplay.hg",
        "simplevaluedisplay.hg",
        ]
    if bld.env["USE_GENERATED_CPP"]:
        gdir = "../gxwmm-generated/"
        for v in sources:
            s = v.replace(".hg", ".cc")
            bld(name = "copy-generated-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
            s = v.replace(".hg", ".h")
            bld(name = "copy-generated-h",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
            s = v.replace(".hg", "_p.h")
            bld(name = "copy-generated-p-h",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + "private/" + s,
                target = "private/" + s,
                )
        bld(name = "copy-wrap_init",
            rule = "cp ${SRC} ${TGT}",
            source = gdir + "wrap_init.cc",
            target = 'wrap_init.cc',
            )
        sources = [v.replace(".hg",".cc") for v in sources]
    else:
        bld(name = "wrap_init",
            rule = bld.env["GMMPROCDIR"]+"/generate_wrap_init.pl --namespace=Gxw ${SRC} >${TGT}; cp ${TGT} ../libgxwmm/gxwmm-generated", #FIXME
            source = sources,
            target = "wrap_init.cc",
            )
        build_generate_wrapper(bld)
    bld.add_group()
    if bld.env["GX_LIB_SHARED"]:
        bld(features = ['cxx', 'cshlib', 'libtool'],
            type = 'cshlib',
            vnum = "0.1",
            includes = ['..','../../libgxw'],
            source = sources+["init.cc","wrap_init.cc"],
            uselib = ['GTKMM'],
            uselib_local = ['gxw'],
            target = 'gxwmm',
            )
    else:
        bld(features = ['cxx', 'cstaticlib'],
            includes = ['..','../../libgxw'],
            source = sources+["init.cc","wrap_init.cc"],
            uselib = ['GTKMM'],
            target = 'gxwmm',
            )

=== src/faust/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def build(bld):
    unused_sources = [
        'preamp.dsp',
        'inputgain.dsp',
        'AntiAlias.dsp',
        'HighShelf.dsp',
        'drive.dsp',
        'osc_tube.dsp',
        'reso_tube.dsp',
        'tube.dsp',
        'tube3.dsp',
        'tubevibrato.dsp',
        'multifilter.dsp',
        'eq.dsp',
        'outputgain.dsp',
        'feed.dsp',
        'balance1.dsp',
        'amp2.dsp',
        'stage3.dsp',
        'distortion.dsp',
        'distortion1.dsp',
        'noisegate.dsp',
        'sloop.dsp', ##float
        ]

    sources = [
        'presence_level.dsp',
        'jconv_post.dsp',
        'cabinet_impulse_former.dsp',
        ]

    sources_plugin_float = [
        'echo.dsp',
        'delay.dsp',
        'chorus.dsp',
        'stereodelay.dsp',
        'stereoecho.dsp',
        ]

    sources_plugin = [
        'low_high_pass.dsp',
        'selecteq.dsp',
        'crybaby.dsp',
        'autowah.dsp',
        'gx_distortion.dsp',
        'impulseresponse.dsp',
        'compressor.dsp',
        'overdrive.dsp',
        'freeverb.dsp',
        'biquad.dsp',
        'tremolo.dsp',
        'phaser_mono.dsp',
        'chorus_mono.dsp',
        'flanger_mono.dsp',
        'gx_feedback.dsp',
        'flanger.dsp',
        'moog.dsp',
        'phaser.dsp',
        'gx_ampmodul.dsp',
        'tonecontroll.dsp',
        'stereoverb.dsp',
        'softclip.dsp',
        'gx_ampout.dsp',
        'noise_shaper.dsp',
        'bassbooster.dsp',
        'gx_outputlevel.dsp',
        'gxfeed.dsp',

        # tone stacks
        'tonestack_default.dsp',
        'tonestack_bassman.dsp',
        'tonestack_twin.dsp',
        'tonestack_princeton.dsp',
        'tonestack_jcm800.dsp',
        'tonestack_jcm2000.dsp',
        'tonestack_mlead.dsp',
        'tonestack_m2199.dsp',
        'tonestack_ac30.dsp',
        'tonestack_soldano.dsp',
        'tonestack_mesa.dsp',
        'tonestack_jtm45.dsp',
        'tonestack_ac15.dsp',
        'tonestack_peavey.dsp',
        'tonestack_ibanez.dsp',
        'tonestack_roland.dsp',
        'tonestack_ampeg.dsp',
        'tonestack_ampeg_rev.dsp',
        'tonestack_sovtek.dsp',
        'tonestack_bogner.dsp',
        'tonestack_groove.dsp',
        'tonestack_crunch.dsp',
        'tonestack_fender_blues.dsp',
        'tonestack_fender_default.dsp',
        'tonestack_fender_deville.dsp',
        'tonestack_gibsen.dsp',

        # amps
        'gxamp.dsp',
        'gxamp2.dsp',
        'gxamp3.dsp',
        'gxamp4.dsp',
        'gxamp5.dsp',
        'gxamp6.dsp',
        'gxamp7.dsp',
        'gxamp8.dsp',
        'gxamp9.dsp',
        'gxamp10.dsp',
        'gxamp11.dsp',
        'gxamp12.dsp',
        'gxamp13.dsp',
        'gxamp14.dsp',
        'gxamp15.dsp',
        'gxamp16.dsp',
        'gxamp17.dsp',

        # bypass mode
        'balance.dsp',
        ]

    if bld.env['FAUST']:
        float_arg = ["-s","40000","-float"]
        if bld.env['FAUST_DOUBLE']:
            arg = ["-double"]
        else:
            arg = ["-float"]
        bld.new_task_gen(
            source = sources,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=no-init"],
            )
        bld.new_task_gen(
            source = sources_plugin,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=plugin"],
            )
        bld.new_task_gen(
            source = sources_plugin_float,
            proc = "../tools/dsp2cc",
            proc_args = float_arg+["--init-type=plugin"]
            )
    else:
        gdir = "../faust-generated/"
        for s in sources + sources_plugin_float + sources_plugin:
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
            )
    bld.add_group()

def configure(conf):
    pass

=== src/gx_head/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def configure(conf):
    pass

def build(bld):
    sources_engine = [
        'gx_jack.cpp',
        'gx_preset.cpp',
        'gx_json.cpp',
        'gx_faust_plugins.cpp',
        'gx_internal_plugins.cpp',
        'gx_engine_audio.cpp',
        'gx_paramtable.cpp',
        'gx_ui.cpp',
        'gx_pitch_tracker.cpp',
        'gx_convolver.cpp',
        'gx_resampler.cpp',
        'gx_system.cpp',
        'gx_engine.cpp',
        'gx_engine_midi.cpp',
        'gx_pluginloader.cpp',
        ]

    sources_gui = [
        'gx_gui_helpers.cpp',
        'gx_main_interface.cpp',
        'gx_child_process.cpp',
        'gx_main_midi.cpp',
        'gx_jconv_settings.cpp',
        'gxw_mm_controllers.cpp',
        'gx_main_boxes.cpp',
        'gx_interface_builder.cpp',
        'gx_mono_rack_builder.cpp',
        'gx_stereo_rack_builder.cpp',
        'gx_cairo_callbacks.cpp',
        'gx_threads.cpp',
        'gx_portmap.cpp',
        'gx_main.cpp',
        ]

    builder_files = [
        'midi.glade',
        'ports.glade',
        'iredit.glade',
        ]

    sources = sources_engine + sources_gui
    incl = ['.','../..','..','../headers','../../libgxwmm','../../libgxw'] # need ".." for config.h
    libpath = []
    lib = ['dl']
    uselib = ['JACK', 'SNDFILE', 'GTHREAD', 'GMODULE_EXPORT',
              'GTK2', 'GTKMM', 'GIOMM', 'FFTW3', 'BOOST_THREAD']
    uselib_local = []
    if bld.env['ZITA_CONVOLVER']:
        uselib.append('ZITA_CONVOLVER')
    else:
        sources.append('../zita-convolver/zita-convolver.cc')
        incl.append('../zita-convolver');
    if bld.env['ZITA_RESAMPLER']:
        uselib.append('ZITA_RESAMPLER')
    else:
        sources.append('../zita-resampler/zita-resampler.cc')
        incl.append('../zita-resampler')
    if bld.env["HAVE_PLUGINLIB"]:
        uselib_local += ["plugins"]
    if bld.env["GX_LIB_SHARED"]:
        lib += ['gxwmm','gxw']
        libpath += [bld.path.find_dir("../../libgxw/gxw").bldpath(bld.env),
                    bld.path.find_dir("../../libgxwmm/gxwmm").bldpath(bld.env)]
    else:
        uselib_local += ['gxwmm','gxw']
    bld(features = 'cxx cprogram',
        includes = incl,
        obj_ext  = '.o',
        source = sources,
        lib = lib,
        uselib = uselib,
        uselib_local = uselib_local,
        libpath = libpath,
        target = bld.env['BIN_NAME1'],
        chmod = 0755,
        install_path = bld.env['BINDIR'],
        )
    bld.install_files(bld.env['GX_BUILDER_DIR1'], builder_files, chmod=0644)

=== src/ladspa/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import os

def configure(conf):
    pass

def build(bld):
    sources = [
        'ladspa_guitarix.cpp',
        ]

    bsources = [
        '../gx_head/gx_json.cpp',
        '../gx_head/gx_faust_plugins.cpp',
        '../gx_head/gx_internal_plugins.cpp',
        '../gx_head/gx_engine_audio.cpp',
        '../gx_head/gx_paramtable.cpp',
        '../gx_head/gx_ui.cpp',
        '../gx_head/gx_pitch_tracker.cpp',
        '../gx_head/gx_convolver.cpp',
        '../gx_head/gx_resampler.cpp',
        '../gx_head/gx_system.cpp',
        '../gx_head/gx_engine.cpp',
        '../gx_head/gx_engine_midi.cpp',
        '../gx_head/gx_pluginloader.cpp',
        '../zita-convolver/zita-convolver.cc',
        '../zita-resampler/zita-resampler.cc',
        '../plugins/zita_rev1.cc',
        ]
    
    for fn in sources:
        src = [fn] + bsources
        ladspa_plugin = bld(
            features='cxx cshlib',
            includes = ['../headers', '..', '../../libgxwmm', '../../libgxw',
                        '../gx_head', '../zita-convolver'],
            uselib = ['GLIBMM','GIOMM','FFTW3','SNDFILE','JACK','BOOST_THREAD'],
            #uselib_local = ["plugins"],
            target   = fn.replace(".cpp",""),
            source   = src,
            #install_path = '${LADSPADIR}',
            install_path = None,
            chmod = 0755,
            )
        ladspa_plugin.env['shlib_PATTERN'] = '%s.so'

=== src/plugins/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import os

sources = [ # generate .so files that can be loaded by guitarix
    ]

lib_sources = [ # put in static library linked with guitarix
    "zita_rev1.dsp",
    ]

def build(bld):
    if bld.env['FAUST']:
        float_arg = ["-s","40000","-float"]
        if bld.env['FAUST_DOUBLE']:
            arg = ["-double"]
        else:
            arg = ["-float"]
        arg += ["--init-type=plugin"]
        bld(name = "dsp2cc sharedlib",
            source = sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = arg+["--template-type=sharedlib"],
            )
        bld(name = "dsp2cc staticlib",
            source = lib_sources,
            proc = "../tools/dsp2cc",
            gen_dir_suffix = "/generated",
            proc_args = arg+["--template-type=staticlib","--in-namespace=pluginlib"],
            )
    else:
        gdir = "generated/"
        for s in sources+lib_sources:
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-plugin-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
            )
    def run(task):
        l = []
        for i in task.inputs:
            s = ("namespace %s { extern PluginDef plugin; }\n"
                 % os.path.splitext(os.path.basename(i.name))[0])
            l.append(s)
        f = file(task.outputs[0].bldpath(task.env),"w")
        f.write('#include "gx_plugin.h"\n\nnamespace pluginlib {\n')
        f.write("".join(l))
        f.write("}\n")
        f.close()
    bld(name = "pluginlib.h",
        source = lib_sources,
        rule = run,
        target = "pluginlib.h",
        )
    bld.add_group()
    have_pluginlib = len(lib_sources) != 0
    bld.env["HAVE_PLUGINLIB"] = have_pluginlib
    if have_pluginlib:
        bld(features = ['cxx', 'cstaticlib'],
            includes = ["../headers"],
            source = [s.replace(".dsp",".cc") for s in lib_sources],
            target = "plugins", # (also defines name of task)
            )
    for s in sources:
        bld(name = "create plugin .so",
            features = ['cxx', 'cshlib'],
            type = 'cshlib',
            includes = ["../headers"],
            source = [s.replace(".dsp",".cc")],
            target = s.replace(".dsp",""),
            )
    

def configure(conf):
    pass

=== debian/changelog ===
guitarix (0.20.2-2) unstable; urgency=low

  * Added patch to fix build on kfreebsd and hurd (Closes: #649634)

 -- Roland Stigge <stigge@antcom.de>  Sun, 27 Nov 2011 19:23:42 +0100

guitarix (0.20.2-1) unstable; urgency=low

  * New upstream release
  * Added to Build-Depends: libboost-thread-dev

 -- Roland Stigge <stigge@antcom.de>  Sat, 12 Nov 2011 16:15:43 +0100

guitarix (0.19.0-1) unstable; urgency=low

  * New upstream release
  * Removed debian/patch/01-fix-convolver.patch: Fixed upstream
  * Removed debian/patches/02-fix-plugin-classes-in-jack-rack.patch:
    Fixed upstream

 -- Roland Stigge <stigge@antcom.de>  Tue, 01 Nov 2011 18:40:23 +0100

guitarix (0.18.0-4) unstable; urgency=low

  * Fix duplicate class names in jack-rack plugins (Closes: #640790)

 -- Roland Stigge <stigge@antcom.de>  Wed, 21 Sep 2011 21:04:32 +0200

guitarix (0.18.0-3) unstable; urgency=low

  * Added upstream fix for convolver (Closes: #639930)
  * Removed package name fix patch

 -- Roland Stigge <stigge@antcom.de>  Mon, 05 Sep 2011 20:47:49 +0200

guitarix (0.18.0-2) unstable; urgency=low

  * Added gtk2-engines, gtk2-engines-pixbuf to Depends to fix guitarix
    widgets on non-GNOME WMs (Closes: #639448)

 -- Roland Stigge <stigge@antcom.de>  Sun, 28 Aug 2011 20:57:55 +0200

guitarix (0.18.0-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Thu, 11 Aug 2011 23:05:05 +0200

guitarix (0.17.0-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Wed, 03 Aug 2011 22:21:41 +0200

=== debian/control ===
Source: guitarix
Section: sound
Priority: extra
Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 7), python, libjack-dev, libsndfile1-dev, libgtk2.0-dev, ladspa-sdk, libzita-convolver-dev, libgtkmm-2.4-dev, libboost-dev, libboost-thread-dev, intltool
Standards-Version: 3.9.2
Homepage: http://guitarix.sourceforge.net/

Package: guitarix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gtk2-engines, gtk2-engines-pixbuf
Recommends: jack-capture, vorbistools, lame
Description: Rock guitar amplifier for Jack
 Guitarix is a rock guitar amplifier for Jack (Jack Audio Connection Kit) with
 one input and two output's. It is designed to get nice trash/metall/rock/guitar
 sounds.  Available are controls for bass, treble, gain, balance, distortion,
 freeverb, crybaby(wah) and echo. For the 'pressure' in the sound you can use
 the feedback and feedforward sliders. guitarix comes with a GTK Interface and
 as Ladspa plugin.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

configure: configure-stamp
configure-stamp:
	dh_testdir
	./waf configure --prefix=/usr --no-faust
	touch configure-stamp

build: build-arch build-indep

build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp  
	dh_testdir

	./waf build 

	touch $@

clean: 
	dh_testdir
	dh_testroot
	./waf distclean
	rm -f build-stamp configure-stamp
	# clean generated leftovers:
	#rm -f src/gx_head/zettberlin_rc
	rm -f po/LINGUAS
	rm -f wscript_dsp.pyc
	rm -rf build

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep 
	dh_installdirs

	./waf install --destdir=$(CURDIR)/debian/guitarix 


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_installman debian/guitarix.1
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
